
.. DO NOT EDIT.
.. THIS FILE WAS AUTOMATICALLY GENERATED BY SPHINX-GALLERY.
.. TO MAKE CHANGES, EDIT THE SOURCE PYTHON FILE:
.. "_as_gen/run_derivatives.py"
.. LINE NUMBERS ARE GIVEN BELOW.

.. only:: html

    .. note::
        :class: sphx-glr-download-link-note

        :ref:`Go to the end <sphx_glr_download__as_gen_run_derivatives.py>`
        to download the full example code.

.. rst-class:: sphx-glr-example-title

.. _sphx_glr__as_gen_run_derivatives.py:


Shamrock math derivatives functions
=======================================

This example shows how to use Shamrock math derivatives functions

.. GENERATED FROM PYTHON SOURCE LINES 7-17

.. code-block:: Python
   :lineno-start: 10




    from math import *

    import matplotlib.pyplot as plt
    import numpy as np

    from shamrock.math import *








.. GENERATED FROM PYTHON SOURCE LINES 19-20

Compute the error associated to a derivative function

.. GENERATED FROM PYTHON SOURCE LINES 20-59

.. code-block:: Python
   :lineno-start: 22



    def err_plot(deriv_func, x, f, df, label):
        h = np.logspace(-16, 0, 100)
        err = []

        for i in range(len(h)):
            _err = deriv_func(x, h[i], f) - df(x)
            err.append(fabs(_err))
        plt.plot(h, err, "o", label=label)


    def analysis(f, df, x0, label):
        plt.figure()

        # fmt: off
        err_plot(deriv_func=derivative_upwind, x=x0, f=f, df=df, label="derivative_upwind")
        err_plot(deriv_func=derivative_centered, x=x0, f=f, df=df, label="derivative_centered")
        err_plot(deriv_func=derivative_3point_forward, x=x0, f=f, df=df, label="derivative_3point_forward")
        err_plot(deriv_func=derivative_3point_backward, x=x0, f=f, df=df, label="derivative_3point_backward")
        err_plot(deriv_func=derivative_5point_midpoint, x=x0, f=f, df=df, label="derivative_5point_midpoint")
        # fmt: on

        plt.xscale("log")
        plt.yscale("log")

        ymin, ymax = plt.gca().get_ylim()
        plt.ylim(ymin, ymax)

        for i in range(1, 4):
            print(i, estim_deriv_step(i))
            plt.vlines(estim_deriv_step(i), 1e-50, 1e50, color="grey", alpha=0.3)

        plt.xlabel("h")
        plt.ylabel("error")
        plt.title(label)
        plt.legend()









.. GENERATED FROM PYTHON SOURCE LINES 60-61

Exemple of analysis

.. GENERATED FROM PYTHON SOURCE LINES 61-87

.. code-block:: Python
   :lineno-start: 63



    def f1(x):
        return exp(x)


    def df1(x):
        return exp(x)


    analysis(f1, df1, 0, "exp(0)")
    analysis(f1, df1, 100, "exp(100)")


    def f2(x):
        return sin(x**2)


    def df2(x):
        return cos(x**2) * 2 * x


    analysis(f2, df2, 0, "sin(0)")
    analysis(f2, df2, 100, "sin(100)")

    plt.show()



.. rst-class:: sphx-glr-horizontal


    *

      .. image-sg:: /_as_gen/images/sphx_glr_run_derivatives_001.png
         :alt: exp(0)
         :srcset: /_as_gen/images/sphx_glr_run_derivatives_001.png
         :class: sphx-glr-single-img

    *

      .. image-sg:: /_as_gen/images/sphx_glr_run_derivatives_002.png
         :alt: exp(100)
         :srcset: /_as_gen/images/sphx_glr_run_derivatives_002.png
         :class: sphx-glr-single-img

    *

      .. image-sg:: /_as_gen/images/sphx_glr_run_derivatives_003.png
         :alt: sin(0)
         :srcset: /_as_gen/images/sphx_glr_run_derivatives_003.png
         :class: sphx-glr-single-img

    *

      .. image-sg:: /_as_gen/images/sphx_glr_run_derivatives_004.png
         :alt: sin(100)
         :srcset: /_as_gen/images/sphx_glr_run_derivatives_004.png
         :class: sphx-glr-single-img


.. rst-class:: sphx-glr-script-out

 .. code-block:: none

    1 1.4901161193847656e-08
    2 6.055454452393344e-06
    3 0.0001220703125
    1 1.4901161193847656e-08
    2 6.055454452393344e-06
    3 0.0001220703125
    1 1.4901161193847656e-08
    2 6.055454452393344e-06
    3 0.0001220703125
    1 1.4901161193847656e-08
    2 6.055454452393344e-06
    3 0.0001220703125





.. rst-class:: sphx-glr-timing

   **Total running time of the script:** (0 minutes 0.849 seconds)

**Estimated memory usage:**  63 MB


.. _sphx_glr_download__as_gen_run_derivatives.py:

.. only:: html

  .. container:: sphx-glr-footer sphx-glr-footer-example

    .. container:: sphx-glr-download sphx-glr-download-jupyter

      :download:`Download Jupyter notebook: run_derivatives.ipynb <run_derivatives.ipynb>`

    .. container:: sphx-glr-download sphx-glr-download-python

      :download:`Download Python source code: run_derivatives.py <run_derivatives.py>`

    .. container:: sphx-glr-download sphx-glr-download-zip

      :download:`Download zipped: run_derivatives.zip <run_derivatives.zip>`


.. only:: html

 .. rst-class:: sphx-glr-signature

    `Gallery generated by Sphinx-Gallery <https://sphinx-gallery.github.io>`_
